#include "proof-type.h"

Tproof_type_desc ps_type_desc[PS_TYPE_MAX + 1] =
  { {NULL, NULL, 0, 0},
    {"input", "{input formula}", 0, 0},
    {"deep_res", "deep resolution in formula", -1, 0},
    {"true", "valid: {true}", 0, 0},
    {"false", "valid: {(not false)}", 0, 0},
    {"and_pos", "valid: {(not (and a_1 ... a_n)) a_i}", 0, 1},
    {"and_neg", "valid: {(and a_1 ... a_n) (not a_1) ... (not a_n)}", 0, 0},
    {"or_pos", "valid: {(not (or a_1 ... a_n)) a_1 ... a_n}", 0, 0},
    {"or_neg", "valid: {(or a_1 ... a_n) (not a_i)}", 0, 1},
    {"xor_pos1", "valid: {(not (xor a b)) a b}", 0, 0},
    {"xor_pos2", "valid: {(not (xor a b)) (not a) (not b)}", 0, 0},
    {"xor_neg1", "valid: {(xor a b) a (not b)}", 0, 0},
    {"xor_neg2", "valid: {(xor a b) (not a) b}", 0, 0},
    {"implies_pos", "valid: {(not (implies a b)) (not a) b}", 0, 0},
    {"implies_neg1", "valid: {(implies a b) a}", 0, 0},
    {"implies_neg2", "valid: {(implies a b) (not b)}", 0, 0},
    {"equiv_pos1", "valid: {(not (iff a b)) a (not b)}", 0, 0},
    {"equiv_pos2", "valid: {(not (iff a b)) (not a) b}", 0, 0},
    {"equiv_neg1", "valid: {(iff a b) (not a) (not b)}", 0, 0},
    {"equiv_neg2", "valid: {(iff a b) a b}", 0, 0},
    {"ite_pos1", "valid: {(not (if_then_else a b c)) a c}", 0, 0},
    {"ite_pos2", "valid: {(not (if_then_else a b c)) (not a) b}", 0, 0},
    {"ite_neg1", "valid: {(if_then_else a b c) a (not c)}", 0, 0},
    {"ite_neg2", "valid: {(if_then_else a b c) (not a) (not b)}", 0, 0},
    {"eq_reflexive", "valid: {(= x x)}", 0, 0},
    {"eq_transitive", "valid: {(not (= x_1 x_2)) ... (not (= x_{n-1} x_n)) (= x_1 x_n)}", 0, 0},
    {"eq_congruent", "valid: {(not (= x_1 y_1)) ... (not (= x_n y_n)) (= (f x_1 ... x_n) (f y_1 ... y_n))}", 0, 0},
    {"eq_congruent_pred", "valid: {(not (= x_1 y_1)) ... (not (= x_n y_n)) (not (p x_1 ... x_n)) (p y_1 ... y_n)}", 0, 0},
    {"distinct_elim", "valid: {(= DIST(...) ... neq ...)}", 0, 0},
    {"chainable_elim", "valid: {(= (f t1 ... tn ) (and (f t1 t2 ) (f t2 t3 ) ... (f tn−1 tn ))}", 0, 0},
    {"right_assoc_elim", "valid: {(= (f t1 ... tn ) (f t1 (f t2 ... (f tn−1 tn ) ... )}", 0, 0},
    {"left_assoc_elim", "valid: {(= (f t1 ... tn ) (f ... (f (f t1 t2 ) t3 ) ... tn )}", 0, 0},
    {"la_rw_eq", "valid: {(= (a = b) (and (a <= b) (b <= a))}", 0, 0},
    {"skolem_hypo", "valid: {(= (let (... (s_i t_i) ...) t) (t[s_i |-> t_i])}", 0, 0},
    {"skolemization", "valid: {(= (let (... (s_i t_i) ...) t) (t[s_i |-> t_i])}", 0, 0},
    {"la_generic", "valid: not yet defined", 0, 0},
    {"lia_generic", "valid: not yet defined", 0, 0},
    {"nla_generic", "valid: not yet defined", 0, 0},
    {"la_disequality", "valid: not yet defined", 0, 0},
    {"la_totality", "valid: {(le t1 t2), (le t2 t1)}", 0, 0},
    {"la_tautology", "valid: linear arithmetic tautology without variable", 0, 0},
    {"forall_inst", "valid: {(implies (forall X (A X)) (A {X \\ t}))}", 0, 0},
    {"exists_inst", "valid: {(implies (A t) (exists X (A {t \\ X})))}", 0, 0},
    {"skolem_ex_ax", "valid: {(not (exists X (A X))), A(sk)} where sk is fresh", 0, 0},
    {"skolem_all_ax", "valid: {(not A(sk)), (forall X (A X))} where sk is fresh", 0, 0},
    {"qnt_distribute_w_lemma", "valid: {(not (A X (iff F1 F2))), (iff (A X (F1)) (A X (F2)))}", 0, 0},
    {"qnt_join", "valid: {(equiv (Q x (Q y (F x y))) (Q x y (F x y)))}", 0, 0},
    {"qnt_rm_unused", "valid: {(equiv (Q x y (F x))) (Q x (F x)))}", 0, 0},
    {"fol_ax", "valid: to be defined [produced by the E prover]", 0, 0},
    {"th_resolution", "resolution of 2 or more clauses from theory reasoner", -1, 0},
    {"resolution", "resolution of 2 or more clauses from SAT solver", -1, 0},
    {"refl", "", -1, 0},
    {"trans", "", -1, 0},
    {"cong", "replacement of 2 or more subformulas for their equivalents", -1, 0},
    {"qnt_distribute_w", "(A X (iff F1 F2))) --> (iff (A X (F1)) (A X (F2)))}", 1, 1},
    {"and", "{(and a_1 ... a_n)} --> {a_i}", 1, 1},
    {"not_or", "{(not (or a_1 ... a_n))} --> {(not a_i)}", 1, 1},
    {"or", "{(or a_1 ... a_n)} --> {a_1 ... a_n}", 1, 0},
    {"not_and", "{(not (and a_1 ... a_n))} --> {(not a_1) ... (not a_n)}", 1, 0},
    {"xor1", "{(xor a b)} --> {a b}", 1, 0},
    {"xor2", "{(xor a b)} --> {(not a) (not b)}", 1, 0},
    {"not_xor1", "{(not (xor a b))} --> {a (not b)}", 1, 0},
    {"not_xor2", "{(not (xor a b))} --> {(not a) b}", 1, 0},
    {"implies", "{(implies a b)} --> {(not a) b}", 1, 0},
    {"not_implies1", "{(not (implies a b))} --> {a}", 1, 0},
    {"not_implies2", "{(not (implies a b))} --> {(not b)}", 1, 0},
    {"equiv1", "{(iff a b)} --> {(not a) b}", 1, 0},
    {"equiv2", "{(iff a b)} --> {a (not b)}", 1, 0},
    {"not_equiv1", "{(not (iff a b))} --> {a b}", 1, 0},
    {"not_equiv2", "{(not (iff a b))} --> {(not a) (not b)}", 1, 0},
    {"ite1", "{(if_then_else a b c)} --> {a c}", 1, 0},
    {"ite2", "{(if_then_else a b c)} --> {(not a) b}", 1, 0},
    {"not_ite1", "{(not (if_then_else a b c))} --> {a (not c)}", 1, 0},
    {"not_ite2", "{(not (if_then_else a b c))} --> {(not a) (not b)}", 1, 0},
    {"tmp_ite_intro", "{(equiv formula (and formula (ite_def_1 ... ite_def_n)))}", 1, 0},
    {"connective_equiv", "logic equivalence", 1, 0},
    {"tmp_AC_simp", "logic equivalence", 1, 0},
    {"tmp_alphaconv", "{formula} --> {alpha conversion with fresh symbols}", 1, 0},
    {"tmp_nary_elim", "{formula} --> {formula where n-ary symbols have been eliminated}", 1, 0},
    {"tmp_distinct_elim", "{formula} --> {formula where distinct have been eliminated}", 1, 0},
    {"tmp_eq_norm", "{formula} --> {formula where eqs between propositions have been turned into equivs}", 1, 0},
    {"tmp_simp_arith", "{formula} --> {formula where arith terms have been normalized}", 1, 0},
    {"tmp_macrosubst", "{formula} --> {formula where macros have been substituted}", 1, 0},
    {"tmp_betared", "{formula} --> {formula where beta reduction has been applied}", 1, 0},
    {"tmp_bfun_elim", "{formula} --> {formula where functions with Boolean arguments have been simplified}", 1, 0},
    {"tmp_sk_connector", "{formula} --> {formula where some connectors have been suppressed for skolemization}", 1, 0},
    {"tmp_pm_process", "{formula} --> {formula where polymorphism has been eliminated}", 1, 0},
    {"tmp_qnt_tidy", "{formula} --> {formula where quantifiers have been normalized}", 1, 0},
    {"tmp_qnt_simplify", "{formula} --> {formula where quantifiers have been simplified}", 1, 0},
    {"tmp_skolemize", "{formula} --> {Skolemized formula}", 1, 0},
    {"tmp_LA_pre", "{formula} --> {formula with = replaced by conjunction of two inequalities}", 1, 0},

    {"subproof", "", 1, 0},
    {"bind", "", 1, 0},
    {"let", "valid: {(= (let (... (s_i t_i) ...) t) (t[s_i |-> t_i]))}", 1, 0},
    {"qnt_simplify", "valid: to be defined", 1, 0},
    {"sko_ex", "", 1, 0},
    {"sko_forall", "", 1, 0},

    {NULL, NULL, 0, 0}
  };
