/*
  --------------------------------------------------------------
  Polarities
  --------------------------------------------------------------
*/

#ifndef __POLARITIES_H
#define __POLARITIES_H

typedef unsigned char Tpol;

enum {
  POL_NONE = 0,
  POL_POS = 1,
  POL_NEG = 2,
  POL_BOTH = 3
};

static inline Tpol INV_POL(const Tpol x)
{
  static Tpol INV[4] = {
    /* POL_NONE: */ POL_NONE,
    /* POL_POS */ POL_NEG,
    /* POL_NEG */ POL_POS,
    /* POL_BOTH */ POL_BOTH
  };
  return INV[x];
}

#define QUANTIFIED_STRONG(DAG, pol)                           \
  ((DAG_symb(DAG) == QUANTIFIER_EXISTS && pol == POL_POS) ||  \
   (DAG_symb(DAG) == QUANTIFIER_FORALL && pol == POL_NEG))
#define QUANTIFIED_WEAK(DAG, pol)                             \
  ((DAG_symb(DAG) == QUANTIFIER_EXISTS && pol == POL_NEG) ||  \
   (DAG_symb(DAG) == QUANTIFIER_FORALL && pol == POL_POS))

#endif /* __POLARITIES_H */
